package spiral.all;

import java.util.*;

/**
 * <p>Title: Spiral analyzis</p>
 * <p>Description: Tda reprezentujc vektor bod spirly</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class DataVector {
  private Vector vec;

  /**
   * Vytvo vektor bod spirly se standartn velikost 1000
   */
  public DataVector() {
    vec = new Vector(1000);
  }

  /**
   * Vytvo vektor bod spirly se zadanou velikost
   * @param size velikost
   */
  public DataVector(int size) {
    vec = new Vector(size);
  }

  /**
   * Vytvo vektor bod spirly z ji existujcho vektoru
   * @param v vektor bod
   */
  public DataVector(DataVector v) {
    int size = v.size();
    vec = new Vector(size);
    for (int i = 0; i < size; i++) {
      vec.add(new DataRow(v.get(i)));
    }
  }

  /**
   * Pevrt poad bod na spirle
   * @return pevrcen vektor
   */
  public DataVector invert() {
    int size = vec.size();
    DataVector res = new DataVector(size);
    for (int i = size - 1; i >= 0; i--) {
      res.add( (DataRow) vec.get(i));
    }
    return res;
  }

  /**
   * Pid nakonec vektoru body jinho vektoru bod
   * @param v vektor bod
   */
  public void append(DataVector v) {
    Iterator i = v.iterator();
    while (i.hasNext()) {
      vec.add(i.next());
    }
  }

  /**
   * Vrac posledn bod na spirle
   * @return posledn bod
   */
  public DataRow lastElement() {
    return (DataRow) vec.lastElement();
  }

  /**
   * Vrac itertor pro pstup k bodm
   * @return itertor
   */
  public Iterator iterator() {
    return vec.iterator();
  }

  /**
   * Pid nakonec vektoru dal bod
   * @param r bod
   */
  public void add(DataRow r) {
    vec.add(r);
  }

  /**
   * Vrac velikost vektoru bod
   * @return velikost
   */
  public int size() {
    return vec.size();
  }

  /**
   * Vrac bod na dan pozici vektoru
   * @param pos pozice
   * @return bod
   */
  public DataRow get(int pos) {
    return (DataRow) vec.get(pos);
  }
}